
var passport = require('passport'),
    mongoose = require('mongoose'),
    User = mongoose.model('User'),
    Location = mongoose.model('Location'),
    Sensor = mongoose.model('Sensor'),
    Rule = mongoose.model('Location'),
    fs = require("fs");
/*
  req.files: 
   { layoutfile: 
      { fieldName: 'layoutfile',
        originalFilename: 'Hall_and_parlor_house_floor_plan.png',
        path: '/tmp/9769-1e1ez7u.png',
        headers: [Object],
        ws: [Object],
        size: 59542,
        name: 'Hall_and_parlor_house_floor_plan.png',
        type: 'image/png' } },
*/
var layoutLocation = "/mnt/layouts/";

exports.create = function(req, res, next) {  
  console.log(req.files);
  
  if(!req.files) return res.send(400);

  var location = new Location({name: req.body.name,
               fileName: req.files.layoutfile.originalFilename,
               user: req.user._id,
  });
  console.log('creating location');
  location.save(function(err, doc){
    
    if(err) throw (err);
    
      fs.rename(req.files.layoutfile.path, layoutLocation + doc._id + req.files.layoutfile.originalFilename  , function(err){
        if(err) return next(err);
        
        console.log("Completed rename", err);
        req.jsonResponse.success = true; 
        req.jsonResponse.currentrule = doc._id;
        
      });
      req.jsonResponse.success = true; 
      req.jsonResponse.currentrule = doc._id;
      next();
  });
};
exports.getImage = function(req, res, next){
  console.log("get image hit sending file"); 
  res.sendFile(layoutLocation + req.location._id + req.fileName);
}
exports.update = function(req, res, next) {
  var rule = req.rule;
  console.log(req.body);
  if(req.body.rule){
    rule.enabled = (req.body.enabled === 'true') ? true : false;
    rule.rule = req.body.rule;
    rule.save(function(err){
      if(err) 
        throw err;
      else
        req.jsonResponse.success = true;
      
      next();
    });
  }else{
    req.jsonResponse.success = false;
    next(); 
  }
}
exports.delete = function(req, res, next){
  req.location.remove(function(err){
    if(err) return next(err);
    else
      req.jsonResponse.sucess = true;
    next();
  });
}
