
var passport = require('passport')
, mongoose = require('mongoose')
, actions = require('../../libs/sensorData.js')
, User = mongoose.model('User')
, Sensor = mongoose.model('Sensor')
, Rule = mongoose.model('Rule')

exports.create = function(req, res, next) {
  var rule = new Rule({name: req.body.name,
               user: req.user._id,
               type: req.body.type,
  });
  console.log('creating rule');
  console.log(req.body);
  switch(req.body.type){
        case 'sensor':
          rule.sensorId = req.body.ref;
          break;
        case 'hook':
          rule.hookId = req.body.ref;
          break;
        case 'time':
          rule.time = req.body.ref;
        default:
          next(new Error("Wrong type of rule"));
      }
  rule.save(function(err, doc){
    if(err) throw (err);
      req.jsonResponse.success = true; 
      req.jsonResponse.currentrule = doc._id;
      next();
  });
}
exports.update = function(req, res, next) {
  var rule = req.rule;
  console.log(req.body);
  if(req.body.rule){
    rule.enabled = (req.body.enabled === 'true') ? true : false;
    rule.rule = req.body.rule;
    rule.save(function(err){
      if(err) 
        throw err;
      else
        req.jsonResponse.success = true;
      
      next();
    });
  }else{
    req.jsonResponse.success = false;
    next(); 
  }
}
exports.delete = function(req, res, next){
  var rule = req.rule;
  rule.remove(function(err){
    if(err) return next(err);
    else
      req.jsonResponse.sucess = true;
    next();
  });
}
