define([
       'http://connector.gridreact.com/socket.io/socket.io.js',
       'jquery'
], function(io, $){
    var socket;
    var connect =  function(cb){
      $(document).ready(function (){
        $.getJSON('/site/connection_key', function(key){
          if(!key) throw new Error("Problem getting API key");
          socket = io.connect('http://connector.gridreact.com');
          socket.on('connect', function(){
            console.log('connected to socket.io');
            socket.emit('auth', key);
          });
          if(cb) cb(socket);

        });
      });
    }
  return {getConnection: function() { return socket }, connect: connect};
});

