$(document).ready(function () {
  $('.editsensor').on('submit', function(e){
    e.preventDefault();
    console.log(this);
    var self = this;
    var url = $(this).attr('action') 
    $.ajax({
      type: 'POST',
      url:url, 
      data :$(this).serialize(),
      success: function(data){
        if(data.result === 'success'){
          if(data.redraw === true){
            $(self).parent().modal('hide');
            document.location.reload();
          }
        }else{
            $(self).parent().modal('hide');
        }
      },
      dataType: 'json'
    });
  });

  $('#dashboard-menu a').click(function(e){
    e.preventDefault();
    var self = this;
    $('#dashboard-menu .active').removeClass('active');
    $(this).parent().addClass('active');
    $('#dashboard-active .active').hide().removeClass('active');
    $($(this).attr('href')).show().addClass('active');
  });
  $('.colorpicker').ColorPicker({
    onSubmit: function(hsb, hex, rgb, el, parent){
      $(el).val(hex);
      $(el).ColorPickerHide();
    },
    onBeforeShow: function(){
      $(this).ColorPickerSetColor(this.value);
    }
  })
  .bind('keyup', function(){
    $(this).ColorPickerSetColor(this.value);
  });
  $(".delete").click(function(e){
    console.log("clicked delete");
    console.log(this);
    var sensor  = this.getAttribute("data-sensor");

    e.preventDefault();
    console.log('Going to delete ' + sensor);
    var jqXhr = $.ajax({
      url: "/site/sensor/" + sensor,
      type: 'DELETE',
    });
    jqXhr.done(function(){
      console.log('sensor deleted');
      window.location = '/site/sensors';
    });
  });

});
