
var mongoose = require('mongoose')
  , Schema = mongoose.Schema
  , _ = require('underscore')



var LocationSchema = new Schema({
    name: String
  , fileName: String
  , user: {type : Schema.ObjectId, ref: 'User'}
  , createdAt : {type : Date, default : Date.now}
});

LocationSchema.index({user: 1});

mongoose.model('Location', LocationSchema);
