$(document).ready(function () {
  $('.createrule').on('submit', function(e){
    e.preventDefault();
    console.log(this);
    var self = this;
    console.log('creating rule');
    var data = $(this).serialize();
    console.log(data);
    $.ajax({
      type: 'POST',
      url: '/site/rule' , 
      data :data,
      success: function(data){
        console.log(data);
        if(data.success){
          $(self).parent().modal('hide');
          window.location = "/site/rule/" + data.currentrule;
        }else{
            $(self).parent().modal('hide');
        }
      },
      dataType: 'json'
    });
  });
  $('.reference').on('change', function(){
    var selected = $(this).find(":selected");
    console.log(selected.attr('refType'));
    $("#type").val(selected.attr('refType'));
  });
  $('#dashboard-menu a').click(function(e){
    e.preventDefault();
    var self = this;
    $('#dashboard-menu .active').removeClass('active');
    $(this).parent().addClass('active');
    $('#dashboard-active .active').hide().removeClass('active');
    $($(this).attr('href')).show().addClass('active');
  });
  var editor = CodeMirror.fromTextArea(document.getElementById("rule"), {
     lineNumbers: true,
     matchBrackets: true,
     theme: 'ambiance',
     extraKeys: {"Enter": "newlineAndIndentContinueComment"}
  });
  $(".selectAll").click(function(e){
    e.preventDefault();
    editor.execCommand("selectAll");
    console.log("selected all");
  });
  $(".delete").click(function(e){
    e.preventDefault();
    console.log('Going to delete');
    var jqXhr = $.ajax({
      type: 'DELETE',
    });
    jqXhr.done(function(){
      console.log('rule deleted');
      window.location = '/site/rule';
    });
  });
  $(".save").click(function(e){
    e.preventDefault();
    console.log(editor.getValue());
    var rule = null; 
    eval("rule = "  + editor.getValue());
    console.log(rule);
    var enabled = $("#enabled").is(':checked');
    console.log("enabled");
    console.log(enabled);
    var jqXhr = $.ajax({
      type: 'PUT',
      data: {rule: rule,
             enabled: enabled}
    });

    jqXhr.done(function(data){
      console.log(data); 
      console.log('xhr request done');
    });
  
  });
});
//TODO super hacky form thing
function updateType (typeString){
    $('#type').value(typeString);
    console.log('type updated to ' + typeString);
}
